"use strict";

var deepCopy = function (obj) {
	return JSON.parse(JSON.stringify(obj));
};

var dmp = new diff_match_patch();
dmp.Diff_EditCost = 0;

var _lineModeDiff = function (text1, text2) {
	var a = dmp.diff_linesToChars_(text1, text2);

	var diffs = dmp.diff_main(a.chars1, a.chars2, false);
	dmp.diff_cleanupEfficiency(diffs);

	dmp.diff_charsToLines_(diffs, a.lineArray);
	return diffs;
};

// Warning - input strings not permitted to contain newlines!
var diffStringLists = function (list1, list2) {
	var diffs = _lineModeDiff(list1.join('\n') + '\n', list2.join('\n') + '\n');

	// expand diffs
	var expanded = [];

	_.each(diffs, function (diff) {
		var lines = [];
		_.each(diff[1].split('\n'), function (line) {
			if (line.length > 0) {
				lines.push(line);
			}
		});

		var action;
		switch (diff[0]) {
			case -1:
				action = "remove";
				break;
			case 0:
				action = "equal";
				break;
			case 1:
				action = "insert";
				break;
			default:
				throw new Error("invalid action");
		}

		expanded.push({
			action: action,
			items: lines
		});
	});

	return expanded;
};

